//H8 RS-232C LIBrary 'h8rslib.h' for YellowIDE by I.N.
//CPU:H8-3664 (AKI-H8-3664),=16MHz,sizeof(int)=16
//ROM:0000h-7FFFh
//RAM:F780h-FF7Fh
//COM:BaudRate=38400bps, StartBit=1, StopBit=1, No-Parity

//2005/05/31 ver.0.1 H8RSLIB̊JJn
//2005/06/01 ver.1.0 
//2005/08/26 ver.1.1 H8RS_CheckRecv()̉ǁi荞ݑΉj
//2005/08/29 ver.1.2 H8RS_Recv()̉ǁi荞ݑΉj
//2008/01/07 ver.1.3 H8RS_Sends()̒ǉ
//2008/10/23 ver.2.0 MOobt@dlƂ
//2011/06/22 ver.2.1 Mobt@̉ H8RS_Send()

//̃wb_t@CgƂYellowIDE̐ݒ肪Kvł
//@vWFNg̐ݒi荞݁j
//  xN^ԍ:23@֐:H8RS_sci3_ir@:C o^邱

#ifndef H8RSLIB_H
#define H8RSLIB_H

// Mobt@̃TCYiŏF1j
#ifndef H8RS_RECVBUFFERSIZE
	#define H8RS_RECVBUFFERSIZE 32
#endif
// Mobt@̃TCYiŏF1j
#ifndef H8RS_SENDBUFFERSIZE
	#define H8RS_SENDBUFFERSIZE 32
#endif

// {[[g(=16.0[MHz],n=0)
// 207 =>  2403.8 [bps] ( 2400ɑ΂+0.16%)
// 103 =>  4807.7 [bps] ( 4800ɑ΂+0.16%)
//  51 =>  9615.4 [bps] ( 9600ɑ΂+0.16%)
//  25 => 19230.8 [bps] (19200ɑ΂+0.16%)
//  15 => 31250.0 [bps] (31250ɑ΂ 0.00%)
//  12 => 38461.5 [bps] (38400ɑ΂+0.16%)
//   8 => 55555.6 [bps] (57600ɑ΂-3.55%)
#ifndef H8RS_BRR
	#define H8RS_BRR 12
#endif

// --- Mobt@ ---
volatile unsigned char H8RS_rbuffer[H8RS_RECVBUFFERSIZE];
// H8RS_recv_wptrn ͎ɏރf[^ʒuw
volatile int H8RS_recv_wptr;
// H8RS_recv_rptrn==-1̂Ƃ̓f[^ȂCȊO͎ɓǂނׂf[^ʒuw
volatile int H8RS_recv_rptr;

// --- Mobt@ ---
volatile unsigned char H8RS_sbuffer[H8RS_SENDBUFFERSIZE];
// H8RS_send_wptrn ͎ɏރf[^ʒuw
volatile int H8RS_send_wptr;
// H8RS_send_rptrn==-1̂Ƃ̓f[^ȂCȊO͎ɓǂނׂf[^ʒuw
volatile int H8RS_send_rptr;

int H8RS_openflag=0;

// SCI3iM/Mj荞݂ŌĂяo
void interrupt H8RS_sci3_ir(void)
{
	unsigned char c;
	int rp;

	if(SSR & 0x38) SSR &= ~0x38;	//G[΃NA
	
	// M
	if(SSR & 0x40){
		c=RDR;	//H8/3664̏ꍇCRDR̓ǂݍ݂ɂRDRF̓NA

		if (H8RS_recv_wptr == H8RS_recv_rptr) goto fin_rx;	//Mobt@t
		H8RS_rbuffer[H8RS_recv_wptr]=c;
		if (H8RS_recv_rptr<0) H8RS_recv_rptr=H8RS_recv_wptr;
		if (++H8RS_recv_wptr == H8RS_RECVBUFFERSIZE) H8RS_recv_wptr=0;
	}

	fin_rx:

	// M
	if(SSR & 0x80){
		rp=H8RS_send_rptr;
		if(rp<0){
			SCR3 &= ~0x80;	//TIE=0
			return;
		}
		TDR=H8RS_sbuffer[rp++];	//H8/3664̏ꍇCTDRւ݂̏ɂTDRE̓NA

		if(rp==H8RS_SENDBUFFERSIZE) rp=0;
		if(rp==H8RS_send_wptr) rp=-1;
		H8RS_send_rptr=rp;
	}
}

// f[^̎M
int H8RS_Recv(unsigned char *buf, int n)
{
	int i,rp;
	
	if(!H8RS_openflag) return 0;

	if(n>H8RS_RECVBUFFERSIZE) n=H8RS_RECVBUFFERSIZE;
	
	for(i=0;i<n;i++){
		rp=H8RS_recv_rptr;
		if (rp<0) break;

		*buf++ = H8RS_rbuffer[rp++];

		if(rp==H8RS_RECVBUFFERSIZE) rp=0;
		if(rp==H8RS_recv_wptr) rp=-1;
		H8RS_recv_rptr=rp;
	}
	return i;
}

// Mobt@̃`FbN
// (obt@Ɋi[ς݂̃f[^oCgPʂŕԂ)
int H8RS_CheckRecv(void)
{
	int rp,wp;
	
	if(!H8RS_openflag)return 0;

	rp=H8RS_recv_rptr;
	wp=H8RS_recv_wptr;

	if (rp<0) return 0;

	if (wp>rp){
		return wp-rp;
	}else{
		return H8RS_RECVBUFFERSIZE-(rp-wp);
	}
}

// Mobt@̃`FbN
// (obt@̋󂫂oCgPʂŕԂ)
int H8RS_CheckSend(void)
{
	int rp,wp;
	
	if(!H8RS_openflag) return 0;

	wp=H8RS_send_wptr;
	rp=H8RS_send_rptr;

	if (rp<0) return H8RS_SENDBUFFERSIZE;

	if (wp>rp){
		return H8RS_SENDBUFFERSIZE-(wp-rp);
	}else{
		return (rp-wp);
	}
}

// Mobt@̃NA
int H8RS_ClearRecv(void)
{
	if(!H8RS_openflag) return 1;

	H8RS_recv_rptr=-1;
	return 0;
}

// Mobt@̃NA
int H8RS_ClearSend(void)
{
	if(!H8RS_openflag) return 1;

	SCR3 &= ~0x80;	//TIE=0;
	H8RS_send_rptr=-1;
	return 0;
}

// P̎M
int H8RS_Getc(void)
{
	unsigned char c;
	if(!H8RS_openflag)return -1;
	if (!H8RS_Recv(&c,1)) return -1;
	return c;
}

// (Ōオ\n/\r/0̂ꂩ)̎M
int H8RS_Gets(unsigned char *s)
{
	int n=0;
	if(!H8RS_openflag)return n;

	for(;;){
		if (H8RS_Recv(s,1)==1) {
			if(*s=='\n' || *s=='\r' || *s==0){
				*s=0;
				n++;
				break;
			}else{
				s++;
				n++;
			}
		}
	}
	return n;
}

// f[^̑M
// (f[^͑Mobt@֊i[)
// sh7125rslib 2.2Ɠl̏C 2011.6.22
int H8RS_Send(unsigned char *buf, int n)
{
	int i,wp;

	if(!H8RS_openflag) return 0;

	for(i=0;i<n;i++){
		wp=H8RS_send_wptr;
		if (wp == H8RS_send_rptr) return i;		//Mobt@t

		H8RS_sbuffer[wp]=*buf++;

		if ((wp+1) == H8RS_SENDBUFFERSIZE) H8RS_send_wptr=0;
		else H8RS_send_wptr++;

		if (H8RS_send_rptr<0) H8RS_send_rptr=wp;

		SCR3 |= 0x80;	// TIE=1
	}
	return n;
}

// P̑M
int H8RS_Putc(unsigned char c)
{
	if(!H8RS_openflag) return 0;
	H8RS_Send(&c,1);
	return 1;
}

// ̑MiŌ\nj
int H8RS_Puts(unsigned char *s)
{
	int n=0;
	if(!H8RS_openflag) return n;
	while(*s){
		H8RS_Putc(*s++);
		n++;
	}
	H8RS_Putc('\n');
	n++;
	return n;
}

// ̑MiŌɉȂj
int H8RS_Sends(unsigned char *s)
{
	int n=0;
	if(!H8RS_openflag) return n;
	while(*s){
		H8RS_Putc(*s++);
		n++;
	}
	return n;
}

// H8RS_Printf()֐gƎst@C̃TCY傫Ȃ
#ifndef H8RS_PRINTF_BUFFERSIZE
	#define H8RS_PRINTF_BUFFERSIZE	256
#endif
int H8RS_Printf(char *format, ...)
{
	va_list vl;
	char buf[H8RS_PRINTF_BUFFERSIZE];

	va_start(vl,format);
	vsprintf(buf,format,vl);

	return H8RS_Puts(buf);
}

// |[g̃I[v
int H8RS_Open(void)
{
	int i;
	if(H8RS_openflag) return 1;
	_di();

	SCR3 = 0x00;	// TE/RE CLEAR
	SMR = 0x00;		// ASYNC 8 BIT, NO-PARITY, 1 STOP BIT, [CKS1,CKS1]=[00](n=0)
	BRR = H8RS_BRR;	//{[[gݒ
	for(i=0;;i++)if(i==130) break;
	SCR3 |= 0x70;	// TE=1,RE=1, RIE=1

	H8RS_recv_wptr=0;
	H8RS_recv_rptr=-1;
	H8RS_send_wptr=0;
	H8RS_send_rptr=-1;
	H8RS_openflag=1;
	_ei();
	return 0;
}

// |[g̃N[Y
int H8RS_Close(void)
{
	if(!H8RS_openflag)return 1;
	SCR3 = 0x00;	// TE/RE/RIE clear
	H8RS_openflag=0;
	return 0;
}

#endif
